package com.bwie.chat.config;

import com.bwie.chat.vo.ThreadPoolExecutorProperties;

import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;


@Log4j2
@Configuration
public class ThreadPoolExecutorConfig {
//    @Value("${chat.coreSize}")
//    private Integer coreSize;
//    @Value("${gmall.coreMax}")
//    private Integer coreMax;

    private final ThreadPoolExecutorProperties threadPoolExecutorProperties;

    public ThreadPoolExecutorConfig(ThreadPoolExecutorProperties threadPoolExecutorProperties) {
        this.threadPoolExecutorProperties = threadPoolExecutorProperties;
    }

    @Bean
    public ThreadPoolExecutor threadPoolExecutor(){
//        int coreSize = 3 * Runtime.getRuntime().availableProcessors();
//        int coreMax = coreSize + 30;
        log.info("size:"+threadPoolExecutorProperties.getCoreSize()+"max:"+threadPoolExecutorProperties.getCoreMax());
        ThreadPoolExecutor threadPoolExecutor = new ThreadPoolExecutor(threadPoolExecutorProperties.getCoreSize(), threadPoolExecutorProperties.getCoreMax(), 5, TimeUnit.SECONDS,
                new LinkedBlockingQueue<>(100));
        return threadPoolExecutor;
    }

}
